Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/HeuristicLab.JsonInterface.csproj
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/HeuristicLab.JsonInterface.csproj	(revision 17599)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/HeuristicLab.JsonInterface.csproj	(revision 17600)
@@ -101,5 +101,5 @@
     <Compile Include="Models\ValueLookupJsonItem.cs" />
     <Compile Include="SingleLineArrayJsonWriter.cs" />
-    <Compile Include="JCGenerator.cs" />
+    <Compile Include="JsonTemplateGenerator.cs" />
     <Compile Include="JsonTemplateInstantiator.cs" />
     <Compile Include="Converters\ConstrainedValueParameterConverter.cs" />
Index: anches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JCGenerator.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JCGenerator.cs	(revision 17599)
+++ 	(revision )
@@ -1,68 +1,0 @@
-﻿using System.Collections.Generic;
-using HeuristicLab.Optimization;
-using Newtonsoft.Json.Linq;
-using HEAL.Attic;
-using System.IO;
-
-namespace HeuristicLab.JsonInterface {
-  /// <summary>
-  /// Class to generate json interface templates.
-  /// </summary>
-  public class JCGenerator {
-
-    public static void GenerateTemplate(string path, IOptimizer optimizer) =>
-      GenerateTemplate(path, optimizer.Name, optimizer);
-
-    public static void GenerateTemplate(string path, string templateName, IOptimizer optimizer) =>
-      GenerateTemplate(path, templateName, optimizer, JsonItemConverter.Extract(optimizer));
-
-    public static void GenerateTemplate(string path, string templateName, IOptimizer optimizer, IJsonItem rootItem) {
-      #region Init
-      JObject template = JObject.Parse(Constants.Template);
-      JArray parameterItems = new JArray();
-      JArray resultItems = new JArray();
-      IList<IJsonItem> jsonItems = new List<IJsonItem>();
-      string fullPath = Path.GetFullPath(path);
-      #endregion
-
-      // recursively filter items with values/ranges/actualNames
-      PopulateJsonItems(rootItem, jsonItems);
-
-      #region Serialize HL File
-      ProtoBufSerializer serializer = new ProtoBufSerializer();
-      string hlFilePath = Path.Combine(fullPath, templateName + ".hl");
-      serializer.Serialize(optimizer, hlFilePath);
-      #endregion
-
-      #region Filter Items
-      foreach (var item in jsonItems) {
-        if (item is IResultJsonItem)
-          resultItems.Add(item.GenerateJObject());
-        else
-          parameterItems.Add(item.GenerateJObject());
-      }
-      #endregion
-
-      #region Set Template Data
-      template[Constants.Metadata][Constants.TemplateName] = templateName;
-      template[Constants.Metadata][Constants.HLFileLocation] = hlFilePath;
-      template[Constants.Parameters] = parameterItems;
-      template[Constants.Results] = resultItems;
-      #endregion
-
-      #region Serialize and write to file
-      File.WriteAllText(fullPath + @"\" + templateName + ".json", SingleLineArrayJsonWriter.Serialize(template));
-      #endregion
-    }
-
-    #region Helper    
-    private static void PopulateJsonItems(IJsonItem item, IList<IJsonItem> jsonItems) {
-      foreach(var x in item) {
-        if (x.Active && !(x is EmptyJsonItem)) {
-          jsonItems.Add(x);
-        }
-      }
-    }
-    #endregion
-  }
-}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonTemplateGenerator.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonTemplateGenerator.cs	(revision 17600)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonTemplateGenerator.cs	(revision 17600)
@@ -0,0 +1,68 @@
+﻿using System.Collections.Generic;
+using HeuristicLab.Optimization;
+using Newtonsoft.Json.Linq;
+using HEAL.Attic;
+using System.IO;
+
+namespace HeuristicLab.JsonInterface {
+  /// <summary>
+  /// Class to generate json interface templates.
+  /// </summary>
+  public class JsonTemplateGenerator {
+
+    public static void GenerateTemplate(string path, IOptimizer optimizer) =>
+      GenerateTemplate(path, optimizer.Name, optimizer);
+
+    public static void GenerateTemplate(string path, string templateName, IOptimizer optimizer) =>
+      GenerateTemplate(path, templateName, optimizer, JsonItemConverter.Extract(optimizer));
+
+    public static void GenerateTemplate(string path, string templateName, IOptimizer optimizer, IJsonItem rootItem) {
+      #region Init
+      JObject template = JObject.Parse(Constants.Template);
+      JArray parameterItems = new JArray();
+      JArray resultItems = new JArray();
+      IList<IJsonItem> jsonItems = new List<IJsonItem>();
+      string fullPath = Path.GetFullPath(path);
+      #endregion
+
+      // recursively filter items with values/ranges/actualNames
+      PopulateJsonItems(rootItem, jsonItems);
+
+      #region Serialize HL File
+      ProtoBufSerializer serializer = new ProtoBufSerializer();
+      string hlFilePath = Path.Combine(fullPath, templateName + ".hl");
+      serializer.Serialize(optimizer, hlFilePath);
+      #endregion
+
+      #region Filter Items
+      foreach (var item in jsonItems) {
+        if (item is IResultJsonItem)
+          resultItems.Add(item.GenerateJObject());
+        else
+          parameterItems.Add(item.GenerateJObject());
+      }
+      #endregion
+
+      #region Set Template Data
+      template[Constants.Metadata][Constants.TemplateName] = templateName;
+      template[Constants.Metadata][Constants.HLFileLocation] = hlFilePath;
+      template[Constants.Parameters] = parameterItems;
+      template[Constants.Results] = resultItems;
+      #endregion
+
+      #region Serialize and write to file
+      File.WriteAllText(fullPath + @"\" + templateName + ".json", SingleLineArrayJsonWriter.Serialize(template));
+      #endregion
+    }
+
+    #region Helper    
+    private static void PopulateJsonItems(IJsonItem item, IList<IJsonItem> jsonItems) {
+      foreach(var x in item) {
+        if (x.Active && !(x is EmptyJsonItem)) {
+          jsonItems.Add(x);
+        }
+      }
+    }
+    #endregion
+  }
+}