Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/NonlinearLeastSquaresConstantOptimizationEvaluator.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/NonlinearLeastSquaresConstantOptimizationEvaluator.cs	(revision 17604)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/Evaluators/NonlinearLeastSquaresConstantOptimizationEvaluator.cs	(revision 17605)
@@ -47,4 +47,5 @@
     public int ConstantOptimizationIterations {
       get { return ConstantOptimizationIterationsParameter.Value.Value; }
+      set { ConstantOptimizationIterationsParameter.Value.Value = value; }
     }
     #endregion
Index: /branches/3040_VectorBasedGP/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleWithOSTest.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleWithOSTest.cs	(revision 17604)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleWithOSTest.cs	(revision 17605)
@@ -184,6 +184,6 @@
       problem.MaximumFunctionArguments.Value = 0;
 
-      var evaluator = new SymbolicRegressionConstantOptimizationEvaluator();
-      evaluator.ConstantOptimizationIterations.Value = 5;
+      var evaluator = new NonlinearLeastSquaresConstantOptimizationEvaluator();
+      evaluator.ConstantOptimizationIterations = 5;
       problem.EvaluatorParameter.Value = evaluator;
       problem.RelativeNumberOfEvaluatedSamplesParameter.Hidden = true;
Index: anches/3040_VectorBasedGP/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/ConstantOptimizationWithVectorsTest.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/ConstantOptimizationWithVectorsTest.cs	(revision 17604)
+++ 	(revision )
@@ -1,5 +1,0 @@
-﻿namespace HeuristicLab.Tests.HeuristicLab.Problems.DataAnalysis {
-  public class ConstantOptimizationWithVectorsTest {
-
-  }
-}
Index: /branches/3040_VectorBasedGP/HeuristicLab.Tests/HeuristicLab.Problems.Instances.DataAnalysis-3.3/TableFileParserTest.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Tests/HeuristicLab.Problems.Instances.DataAnalysis-3.3/TableFileParserTest.cs	(revision 17604)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Tests/HeuristicLab.Problems.Instances.DataAnalysis-3.3/TableFileParserTest.cs	(revision 17605)
@@ -637,9 +637,11 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName,
-          deCultureInfo.NumberFormat,
-          deCultureInfo.DateTimeFormat,
-          '\t',
-          true);
+        parser.Parse(
+          tempFileName,
+          new TableFileFormatOptions {
+            NumberFormat = deCultureInfo.NumberFormat,
+            DateTimeFormat = deCultureInfo.DateTimeFormat,
+            ColumnSeparator = '\t'
+          }, columnNamesInFirstLine: true);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -676,8 +678,9 @@
       try {
         parser.Parse(tempFileName,
-          CultureInfo.InvariantCulture.NumberFormat,
-          CultureInfo.InvariantCulture.DateTimeFormat,
-          ',',
-          parser.AreColumnNamesInFirstLine(tempFileName));
+          new TableFileFormatOptions {
+            NumberFormat = CultureInfo.InvariantCulture.NumberFormat,
+            DateTimeFormat = CultureInfo.InvariantCulture.DateTimeFormat,
+            ColumnSeparator = ','
+          }, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -716,7 +719,9 @@
         try {
           parser.Parse(tmpFileName,
-            CultureInfo.InvariantCulture.NumberFormat,
-            CultureInfo.InvariantCulture.DateTimeFormat,
-            separator: ',', columnNamesInFirstLine: true);
+            new TableFileFormatOptions {
+              NumberFormat = CultureInfo.InvariantCulture.NumberFormat,
+              DateTimeFormat = CultureInfo.InvariantCulture.DateTimeFormat,
+              ColumnSeparator = ','
+            }, columnNamesInFirstLine: true);
           Assert.IsTrue(parser.Values[0] is List<double>);
           Assert.AreEqual(double.NaN, parser.Values[0][0]);
@@ -746,7 +751,9 @@
         try {
           parser.Parse(tmpFileName,
-            CultureInfo.InvariantCulture.NumberFormat,
-            CultureInfo.InvariantCulture.DateTimeFormat,
-            separator: ',', columnNamesInFirstLine: true);
+            new TableFileFormatOptions {
+              NumberFormat = CultureInfo.InvariantCulture.NumberFormat,
+              DateTimeFormat = CultureInfo.InvariantCulture.DateTimeFormat,
+              ColumnSeparator = ','
+            }, columnNamesInFirstLine: true);
           Assert.IsTrue(parser.Values[0] is List<string>);
           Assert.AreEqual(string.Empty, parser.Values[0][0]);
@@ -777,7 +784,9 @@
         try {
           parser.Parse(tmpFileName,
-            CultureInfo.InvariantCulture.NumberFormat,
-            CultureInfo.InvariantCulture.DateTimeFormat,
-            separator: ',', columnNamesInFirstLine: true);
+            new TableFileFormatOptions {
+              NumberFormat = CultureInfo.InvariantCulture.NumberFormat,
+              DateTimeFormat = CultureInfo.InvariantCulture.DateTimeFormat,
+              ColumnSeparator = ','
+            }, columnNamesInFirstLine: true);
           Assert.IsTrue(parser.Values[0] is List<string>);
           Assert.AreEqual(string.Empty, parser.Values[0][0]);
@@ -809,7 +818,9 @@
         try {
           parser.Parse(tmpFileName,
-            CultureInfo.GetCultureInfo("de-de").NumberFormat,
-            CultureInfo.GetCultureInfo("de-de").DateTimeFormat,
-            separator: ',', columnNamesInFirstLine: true);
+            new TableFileFormatOptions {
+              NumberFormat = CultureInfo.GetCultureInfo("de-de").NumberFormat,
+              DateTimeFormat = CultureInfo.GetCultureInfo("de-de").DateTimeFormat,
+              ColumnSeparator = ','
+            }, columnNamesInFirstLine: true);
           Assert.IsTrue(parser.Values[0] is List<DateTime>);
           Assert.AreEqual(new DateTime(2016, 6, 19), parser.Values[0][0]);
@@ -823,7 +834,9 @@
 
           parser.Parse(tmpFileName,
-            CultureInfo.InvariantCulture.NumberFormat,
-            CultureInfo.InvariantCulture.DateTimeFormat,
-            separator: ',', columnNamesInFirstLine: true);
+            new TableFileFormatOptions {
+              NumberFormat = CultureInfo.InvariantCulture.NumberFormat,
+              DateTimeFormat = CultureInfo.InvariantCulture.DateTimeFormat,
+              ColumnSeparator = ','
+            }, columnNamesInFirstLine: true);
           Assert.IsTrue(parser.Values[0] is List<DateTime>);
           Assert.AreEqual(new DateTime(2016, 6, 19), parser.Values[0][0]);
@@ -848,7 +861,9 @@
         try {
           parser.Parse(tmpFileName,
-            CultureInfo.InvariantCulture.NumberFormat,
-            CultureInfo.InvariantCulture.DateTimeFormat,
-            separator: ',', columnNamesInFirstLine: true);
+            new TableFileFormatOptions {
+              NumberFormat = CultureInfo.InvariantCulture.NumberFormat,
+              DateTimeFormat = CultureInfo.InvariantCulture.DateTimeFormat,
+              ColumnSeparator = ','
+            }, columnNamesInFirstLine: true);
           Assert.IsTrue(parser.Values[0] is List<string>); // time values should be parsed as strings
           Assert.AreEqual("8:15", parser.Values[0][0]);
@@ -884,7 +899,9 @@
         try {
           parser.Parse(tmpFileName,
-            CultureInfo.InvariantCulture.NumberFormat,
-            CultureInfo.InvariantCulture.DateTimeFormat,
-            separator: ',', columnNamesInFirstLine: true);
+            new TableFileFormatOptions {
+              NumberFormat = CultureInfo.InvariantCulture.NumberFormat,
+              DateTimeFormat = CultureInfo.InvariantCulture.DateTimeFormat,
+              ColumnSeparator = ','
+            }, columnNamesInFirstLine: true);
           // Parse should fail with an exception
           Assert.Fail("expected exception TableFileParser.DataFormatException");
@@ -915,7 +932,9 @@
         try {
           parser.Parse(tmpFileName,
-            CultureInfo.InvariantCulture.NumberFormat,
-            CultureInfo.InvariantCulture.DateTimeFormat,
-            separator: ',', columnNamesInFirstLine: true);
+            new TableFileFormatOptions {
+              NumberFormat = CultureInfo.InvariantCulture.NumberFormat,
+              DateTimeFormat = CultureInfo.InvariantCulture.DateTimeFormat,
+              ColumnSeparator = ','
+            }, columnNamesInFirstLine: true);
           Assert.IsTrue(parser.Values[0] is List<double>);
           Assert.IsTrue(parser.Values[1] is List<string>);