Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/MultiObjectiveProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/MultiObjectiveProblem.cs	(revision 17609)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/MultiObjectiveProblem.cs	(revision 17610)
@@ -38,10 +38,10 @@
     where TEncoding : class, IEncoding<TEncodedSolution>
     where TEncodedSolution : class, IEncodedSolution {
-    #region Parameternames
+    #region Parameter names
     public const string BestKnownFrontParameterName = "BestKnownFront";
     public const string ReferencePointParameterName = "ReferencePoint";
     #endregion
 
-    #region Parameterproperties
+    #region Parameter properties
     [Storable] public IValueParameter<BoolArray> MaximizationParameter { get; }
     public IValueParameter<DoubleMatrix> BestKnownFrontParameter {
@@ -63,19 +63,9 @@
     }
 
-    protected MultiObjectiveProblem() : base() {
-      MaximizationParameter = new ValueParameter<BoolArray>("Maximization", "The dimensions correspond to the different objectives: False if the objective should be minimized, true if it should be maximized..", new BoolArray(new bool[] { }, @readonly: true));
-      Parameters.Add(MaximizationParameter);
-      Parameters.Add(new OptionalValueParameter<DoubleMatrix>(BestKnownFrontParameterName, "A double matrix representing the best known qualites for this problem (aka points on the Pareto front). Points are to be given in a row-wise fashion."));
-      Parameters.Add(new OptionalValueParameter<DoubleArray>(ReferencePointParameterName, "The refrence point for hypervolume calculations on this problem"));
-      Operators.Add(Evaluator);
-      Operators.Add(new MultiObjectiveAnalyzer<TEncodedSolution>());
-      ParameterizeOperators();
-    }
-
     protected MultiObjectiveProblem(TEncoding encoding) : base(encoding) {
       MaximizationParameter = new ValueParameter<BoolArray>("Maximization", "The dimensions correspond to the different objectives: False if the objective should be minimized, true if it should be maximized..", new BoolArray(new bool[] { }, @readonly: true));
       Parameters.Add(MaximizationParameter);
       Parameters.Add(new OptionalValueParameter<DoubleMatrix>(BestKnownFrontParameterName, "A double matrix representing the best known qualites for this problem (aka points on the Pareto front). Points are to be given in a row-wise fashion."));
-      Parameters.Add(new OptionalValueParameter<DoubleArray>(ReferencePointParameterName, "The refrence point for hypervolume calculations on this problem"));
+      Parameters.Add(new OptionalValueParameter<DoubleArray>(ReferencePointParameterName, "The reference point for hypervolume calculations on this problem"));
       Operators.Add(Evaluator);
       Operators.Add(new MultiObjectiveAnalyzer<TEncodedSolution>());
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Problem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Problem.cs	(revision 17609)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Problem.cs	(revision 17610)
@@ -101,16 +101,5 @@
     }
 
-    protected Problem()
-      : base() {
-      Parameters.Add(new ValueParameter<TEncoding>("Encoding", "Describes the configuration of the encoding, what the variables are called, what type they are and their bounds if any.") { Hidden = true });
-      Parameters.Add(new ValueParameter<TEvaluator>("Evaluator", "The operator used to evaluate a solution.") { Hidden = true });
-
-      if (Encoding != null) {
-        oldEncoding = Encoding;
-        Parameterize();
-      }
-      RegisterEvents();
-    }
-    protected Problem(TEncoding encoding) {
+    protected Problem(TEncoding encoding) : base() {
       if (encoding == null) throw new ArgumentNullException("encoding");
       Parameters.Add(new ValueParameter<TEncoding>("Encoding", "Describes the configuration of the encoding, what the variables are called, what type they are and their bounds if any.", encoding) { Hidden = true });
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/SingleObjectiveProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/SingleObjectiveProblem.cs	(revision 17609)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/SingleObjectiveProblem.cs	(revision 17610)
@@ -72,22 +72,4 @@
       BestKnownQualityParameter = cloner.Clone(original.BestKnownQualityParameter);
       MaximizationParameter = cloner.Clone(original.MaximizationParameter);
-      Parameterize();
-      RegisterEventHandlers();
-    }
-
-    protected SingleObjectiveProblem() : base() {
-      MaximizationParameter = new ValueParameter<BoolValue>("Maximization", "Whether the problem should be maximized (True) or minimized (False).", new BoolValue(false).AsReadOnly()) { Hidden = true, ReadOnly = true };
-      BestKnownQualityParameter = new OptionalValueParameter<DoubleValue>("BestKnownQuality", "The quality of the best known solution of this problem.");
-
-      Parameters.Add(MaximizationParameter);
-      Parameters.Add(BestKnownQualityParameter);
-
-      Operators.Add(Evaluator);
-      Operators.Add(new SingleObjectiveAnalyzer<TEncodedSolution>());
-      Operators.Add(new SingleObjectiveImprover<TEncodedSolution>());
-      Operators.Add(new SingleObjectiveMoveEvaluator<TEncodedSolution>());
-      Operators.Add(new SingleObjectiveMoveGenerator<TEncodedSolution>());
-      Operators.Add(new SingleObjectiveMoveMaker<TEncodedSolution>());
-
       Parameterize();
       RegisterEventHandlers();